using System;
using System.Drawing;
using System.Windows.Forms;
using Zcu.Mve.Core;

namespace Examples
{
	/// <summary>
	/// User defined UserControl to setup NumberSource module.
	/// </summary>
	public class NumberSourceSetup : ModuleSetup
	{
//---------------------------------------- ATTRIBUTE --------------------------------------------------//

		#region Attributes component - designer generated code
		private NumericUpDown numericUpDown;
		private CheckBox checkBox;
		private Label label;
		#endregion

		/// <summary>Asociace s modulem.</summary>
		private NumberSource numberSource;

//---------------------------------------- CONSTRUCTOR --------------------------------------------------//
	
		/// <summary>
		/// Inicializes member variables and GUI.
		/// </summary>
		/// <param name="numberSource">modul numberSource</param>
		public NumberSourceSetup(NumberSource numberSource)
		{
			this.InitializeComponent();

			this.numberSource = numberSource;
			this.checkBox.Checked = (numberSource.random != null);
			this.numericUpDown.Value = (decimal) numberSource.val;
		}

		#region Inicialize component - designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.numericUpDown = new System.Windows.Forms.NumericUpDown();
      this.label = new System.Windows.Forms.Label();
      this.checkBox = new System.Windows.Forms.CheckBox();
      ((System.ComponentModel.ISupportInitialize)(this.numericUpDown)).BeginInit();
      this.SuspendLayout();
      // 
      // numericUpDown
      // 
      this.numericUpDown.Location = new System.Drawing.Point(4, 44);
      this.numericUpDown.Maximum = new System.Decimal(new int[] {
                                                                  -559939584,
                                                                  902409669,
                                                                  54,
                                                                  0});
      this.numericUpDown.Minimum = new System.Decimal(new int[] {
                                                                  -559939584,
                                                                  902409669,
                                                                  54,
                                                                  -2147483648});
      this.numericUpDown.Name = "numericUpDown";
      this.numericUpDown.Size = new System.Drawing.Size(112, 20);
      this.numericUpDown.TabIndex = 0;
      this.numericUpDown.Value = new System.Decimal(new int[] {
                                                                1,
                                                                0,
                                                                0,
                                                                0});
      // 
      // label
      // 
      this.label.Location = new System.Drawing.Point(4, 28);
      this.label.Name = "label";
      this.label.Size = new System.Drawing.Size(112, 16);
      this.label.TabIndex = 1;
      this.label.Text = "Value";
      // 
      // checkBox
      // 
      this.checkBox.Location = new System.Drawing.Point(4, 4);
      this.checkBox.Name = "checkBox";
      this.checkBox.Size = new System.Drawing.Size(112, 16);
      this.checkBox.TabIndex = 2;
      this.checkBox.Text = "Random";
      this.checkBox.CheckedChanged += new System.EventHandler(this.checkBox_CheckedChanged);
      // 
      // NumberSourceSetup
      // 
      this.Controls.Add(this.checkBox);
      this.Controls.Add(this.label);
      this.Controls.Add(this.numericUpDown);
      this.Name = "NumberSourceSetup";
      this.Size = new System.Drawing.Size(120, 68);
      ((System.ComponentModel.ISupportInitialize)(this.numericUpDown)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

//---------------------------------------- EVENT --------------------------------------------------//

		/// <summary>
		/// It saves new setting. It can disable dialog closing by returning of "false" value.
		/// </summary>
		public override bool OnOkClick()
		{
			if (this.checkBox.Checked)
				this.numberSource.random = new Random();
			else
				this.numberSource.random = null;
			this.numberSource.val = (double) this.numericUpDown.Value;

      this.numberSource.dataSame = false;
      
      return true;
		}

		/// <summary>
		/// User defined method to handle checbox
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="evn"></param>
		private void checkBox_CheckedChanged(object sender, EventArgs evn)
		{
      this.numberSource.dataSame = false;
			this.numericUpDown.Enabled = !this.checkBox.Checked;
		}
	}
}

